﻿
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    .help-block {
        color: red;
    }
</style>

@section HeadLibrary{
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/dist/css/jquery.treeview.css">

}


<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Group Access</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
            <button type="button" class="btn btn-success"  onclick="addGroup()">
                <i class="fa fa-plus-circle fa"></i>  Tambah Data
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <table id="dataMasterGroup" class="table table-bordered table-striped table-hover" role="grid" aria-describedby="dataMasterKaryawan_info" style="width:100%">
            <thead>
                <tr>
                    <th>
                        @Html.DisplayName("ID Group")
                    </th>
                    <th>
                        @Html.DisplayName("Nama Group")
                    </th>
                    <th>
                        @Html.DisplayName("Action")
                    </th>
                </tr>
            </thead>
        </table>

    </div>
    <!-- /.card-body -->
</div>
<!-- /.card -->
<!-- /.modal Add start -->
<div class="modal fade" id="modal_form">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Karyawan Form</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form" id="form_group">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="IDGroup">ID Group</label>
                            <input name="IDGroup" placeholder="ID Group" id="IDGroup" class="form-control" type="text">
                            <span id="span_id_group" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="NamaGroup">Nama Group</label>
                            <input name="NamaGroup" placeholder="Nama Group" id="NamaGroup" class="form-control" type="text">
                            <span id="span_nama_group" class="help-block"></span>
                        </div>

                        <div class="form-group" >
                            <input type="hidden" value="" name="AccountGroupID" id="AccountGroupID" />
                            <div id="tree-container" style="max-height:500px; overflow-y:auto;"></div>
                            <span id="span_AccountGroupID" class="help-block"></span>
                        </div>
                    </div>
                    <!-- /.card-body -->

                    <div class="card-footer d-flex">
                        <button type="button" id="btnSave" onclick=saveGroup() class="btn btn-primary mx-auto" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Add end -->

<div class="modal fade" id="modal_treeview" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h3 class="modal-title2" id="title_role"></h3>
            </div>
            @*
        <div class="modal-body form">
            <form action="#" id="form_set_role" class="form-horizontal">
                <input type="hidden" value="" name="AccountGroupID" id="AccountGroupID" />
                <div id="tree-container" style="max-height:500px; overflow-y:auto;"></div>
            </form>
        </div>
            *@
            <div class="modal-footer">
                <button type="button" id="btnSave_role" onclick="save_role()" class="btn btn-primary">Save</button>
                <button type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
            </div>
        </div>
    </div>
</div>
@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>

    <script src="@Url.Content("~/AdminLTE/plugins/jstree/jstree.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/dist/js/jquery-checktree.js")"></script>
    <script src="@Url.Content("~/AdminLTE/dist/js/jquery.treeview.js")"></script>
    <!-- AdminLTE App -->
    <script src="~/AdminLTE/dist/js/adminlte.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <script src="~/AdminLTE/dist/js/demo.js"></script>


}

@section AdditionalScript{
    <script type="text/javascript">
        let selectedValues = new Array();
        masterKaryawanTable = $("#dataMasterGroup").DataTable({

                "responsive": true,
                "autoWidth": false,
                "ajax": {
                    "url": '@Url.Action("GetDataMasterGroup")',
                    "type": "POST",
                    "datatype": "JSON",
                    "data": function (data) {

                    }
                },

                "columns": [
                    { "data": "id_group", "name": "id_group" },
                    { "data": "nama_group", "name": "nama_group" },
                    {
                        data: null, render: function (data, type, row) {
                            return '<button type="button" data-toggle="modal" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light" style="margin-right: 5px;" onclick="editGroup(\'' + data.id_group + '\')"><i class="fas fa-edit"></i></button>   <button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteGroup(\'' + data.id_group + '\')"><i class="fa fa-trash-alt"></i></button>'

                        }

                    },
                ],

            });
        $('.select2').select2()
        $('#SelectKaryawan').parents('.bootbox').removeAttr('tabindex');
        $('#SelectKaryawan').select2({
                multiple: true,
                allowClear: true,
                placeholder: '--- Pilih Karyawan ---',
                width: '100%',
                theme: 'bootstrap4',
                search:true,
                ajax: {
                    url: '@Url.Content("~/MasterKaryawan/GetDataKaryawan")',
                    dataType: 'JSON',
                    type: "POST",
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data, function (item) {
                                return {
                                    text: item.nama,
                                    id: item.id_karyawan,
                                }
                            })
                        };
                    },
                    cache: true
                }
            });
        function set_role(id) {
           // $('#modal_treeview').modal('show');
            $("#MenuAccess").checktree();
            $(".navigasi").treeview({
                collapsed: true,
                persist: "location",
                control: "#treecontrol"
            });

        $.ajax({
            contentType: 'application/JSON; charset=utf-8',
            type: 'POST',
            url: '@Url.Content("~/GroupAccess/GetTreview")',
            data: JSON.stringify({ "AccountGroupID": id }),
            success: function (data) {
                //$("#title_role").text("Rubah Akses Menu User");
                //$('#modal_treeview').modal('show'); // show bootstrap modal when complete loaded
                $("#AccountGroupID").val(id);
                $('#tree-container').html(data);
                $("#MenuAccess").checktree();


                $(".navigasi").treeview({
                    collapsed: true,
                    persist: "location",
                    control: "#treecontrol"
                });
            },
            error: function (e) {
                alert(e.responseText);
            }
        });
        }
        function addGroup() {
            save_method = 'add';
            $('.help-block').empty();
            document.getElementById("form_group").reset();
            $('#AccountGroupID').empty();
            $('#tree-container').empty();
            //document.getElementById("tree-container").reset();
            //document.getElementById("MenuAccess").reset();
            //document.getElementById("AccountGroupID").reset();
           ///$("#AccountGroupID").val(id);
           // $('#tree-container').html(data);
           // $("#MenuAccess").checktree();

            $('#IDGroup').attr("readonly", false);
            $('.modal-title').text('Tambah Data Group');
            $('#modal_form').modal('show');
        }
        async function editGroup(id_group) {
           // await getKaryawanGroup(id_group);
            save_method = 'update';
            $('.help-block').empty();
            document.getElementById("form_group").reset();
            //$('#SelectKaryawan').empty();
            $('.modal-title').text('Edit Data Group');
            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_group,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#IDGroup').val(result.response[0].id_group).trigger('change');
                            $('#NamaGroup').val(result.response[0].nama_group).trigger('change');
                            selectedValues.forEach(function (e) {
                                if (!$('#SelectKaryawan').find('option:contains(' + e + ')').length)
                                    $('#SelectKaryawan').append($('<option>').text(e));
                            });
                            $('#SelectKaryawan').val(selectedValues).trigger("change");
                            $('#IDGroup').attr("readonly", true);
                            set_role(id_group);

                            $('#modal_form').modal('show');
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }

        

        function save_role() {
          var form = "form_group";
        $.ajax({
            url: '@Url.Content("~/GroupAccess/saveRole")',
            type: "POST",
            data: $('#' + form).serialize(),
            dataType: "JSON",
            success: function (data) {
                if (data == "Success") //if success close modal and reload ajax table
                {
                   // return toastr.success('Berhasil.', 'Hak akses berhasil disimpan', { "timeOut": 5000 });
                }
                else {
                  // return toastr.success('Gagal', 'Hak akses gagal disimpan. ' + data, { "timeOut": 5000 });
               }

              },
            error: function (jqXHR, textStatus, errorThrown) {
                alert('Error adding / update data');
                return toastr.success('Gagal', 'Hak akses gagal disimpan. ' + data, { "timeOut": 5000 });
            }
        });
        }
        function saveGroup() {
            var validate = true;
            var url;
            if ($('#IDGroup').val() == "") {
                $('#span_id_group').text('ID Group Harus diisi');
                validate = false;
            }
            if ($('#NamaGroup').val() == "") {
                $('#span_nama_group').text('Nama Group Harus diisi');
                validate = false;
            }


            if (!validate) {
                return;
            }
            $('#btnSave').text('Menyimpan...'); //change button textbtn_import_medion
            $('#btnSave').attr('disabled', true);

            if (save_method == 'add') {
                url = '@Url.Action("Create")';
            }
            else if (save_method == 'update') {
                url = "@Url.Action("Update")";
            }
            $.ajax({
                url: url,
                method: "POST",
                dataType: "JSON",
                data: {
                    "masterGroup": {
                        "id_group": $('#IDGroup').val(),
                        "nama_group": $('#NamaGroup').val(),
                    }

                },
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (result) {
                    Swal.close();
                    if (result.metaData.code === '200') {
                        $('#modal_form').modal('hide');
                        masterKaryawanTable.ajax.reload();
                        $('#btnSave').text('Simpan Data'); //change button text
                        $('#btnSave').attr('disabled', false); //set button enable
                            if (save_method == 'update') {
                               // set_role($('#IDGroup').val());
                                save_role();
                            }
                       return toastr.success('Data berhasil disimpan.', 'Berhasil!', { "timeOut": 5000 });

                    } else {
                        $('#btnSave').text('Simpan Data'); //change button text
                        $('#btnSave').attr('disabled', false); //set button enable
                        return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    $('#btnSave').text('Simpan Data'); //change button text
                    $('#btnSave').attr('disabled', false); //set button enable
                    return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function deleteGroup(id_group) {
            console.log(id_group);
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    return fetch('@Url.Action("DeleteGroup")' + "/" + id_group, {
                        method: 'POST'
                    }).then(response => {
                        if (!response.ok) {
                            return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                        }
                        return response.json();
                    }).then(result => {
                        if (result.metaData.code === '200') {
                            masterKaryawanTable.ajax.reload();
                            return toastr.success('Data berhasil dihapus', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!  Akses Group Harus di Hapus Terlebih Dahulu', { "timeOut": 5000 });
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
    </script>
}

